/*

*/

/**

*/
public class ProducerConsumer
{
   public static void main(String[] args)
   {
      Buffer buf = new Buffer(40); // half full
      //Buffer buf = new Buffer_locked(40);
      //Buffer buf = new Buffer_unbounded(40);
      //Buffer buf = new Buffer_bounded(40);
      Producer producer = new Producer(buf, 40);
      Consumer consumer = new Consumer(buf, 50);
      Thread t1 = new Thread(producer);
      Thread t2 = new Thread(consumer);
      t1.start();
      t2.start();

      try
      {
         Thread.sleep(10_000);
       //Thread.sleep(300_000); // 5 minutes

         t1.interrupt();
         t2.interrupt();

         t1.join();
         t2.join();
      }
      catch (InterruptedException e)
      {
      }
   }
}


class Producer implements Runnable
{
   private final Buffer buf;
   private final int milliSeconds;

   public Producer(Buffer buf)
   {
      this.buf = buf;
      this.milliSeconds = 500;
   }

   public Producer(Buffer buf, int milliSeconds)
   {
      this.buf = buf;
      this.milliSeconds = milliSeconds;
   }

   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {
            buf.put();
            System.out.println(buf);
            Thread.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
      }
   }
}


class Consumer implements Runnable
{
   private final Buffer buf;
   private final int milliSeconds;

   public Consumer(Buffer buf)
   {
      this.buf = buf;
      this.milliSeconds = 500;
   }

   public Consumer(Buffer buf, int milliSeconds)
   {
      this.buf = buf;
      this.milliSeconds = milliSeconds;
   }

   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {
            buf.get();
            System.out.println(buf);
            Thread.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
