/*

*/

/**

*/
public class ProducerConsumer
{
   public static void main(String[] args)
   {
      Buffer buf = new Buffer_bounded(0, 1); // empty buffer of size 1
      Producer producer = new Producer(buf, 0);
      Consumer consumer = new Consumer(buf, 0);
      Thread t1 = new Thread(consumer);
      Thread t2 = new Thread(consumer);
      Thread t3 = new Thread(producer);
      t1.start();
      t2.start();
      t3.start();

      try
      {
       //Thread.sleep(10_000);
         Thread.sleep(300_000); // 5 minutes

         t1.interrupt();
         t2.interrupt();
         t3.interrupt();

         t1.join();
         t2.join();
         t3.join();
      }
      catch (InterruptedException e)
      {
      }
   }
}


class Producer implements Runnable
{
   private final Buffer buf;
   private final int milliSeconds;

   public Producer(Buffer buf)
   {
      this.buf = buf;
      this.milliSeconds = 500;
   }

   public Producer(Buffer buf, int milliSeconds)
   {
      this.buf = buf;
      this.milliSeconds = milliSeconds;
   }

   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {
            buf.put();
            System.out.println(buf);
            Thread.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
      }
   }
}


class Consumer implements Runnable
{
   private final Buffer buf;
   private final int milliSeconds;

   public Consumer(Buffer buf)
   {
      this.buf = buf;
      this.milliSeconds = 500;
   }

   public Consumer(Buffer buf, int milliSeconds)
   {
      this.buf = buf;
      this.milliSeconds = milliSeconds;
   }

   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {
            buf.get();
            System.out.println(buf);
            Thread.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
